//+------------------------------------------------------------------+
//|                              Custom candles - any time frame.mq4 |
//+------------------------------------------------------------------+
/*
9/11/21 button version https://forex-station.com/viewtopic.php?p=1295444477#p1295444477

2022-May-27 v2 by pips4life --
   Some cleanup of the previous utterly terrible implementation of the added on/off "button".  (This wasn't done by mladen, AFAIK)
   
   I've annotated some of the problems and cleanup using "P4L: " as a prefix to comments added.
   
   NOTE: I've left a lot of GARBAGE/commented out sections so it's more obvious what I have changed.  Ultimately, many comments could be removed for clarity.
   
   The OnChartEvents() section was hugely inefficient, calling the "start()" or "deinit2()" (which does a foreach of all objects!)  hundreds/thousands of times extra just by moving
      the mouse around.  Furthermore, it would HANG MT4 if any *other* indicator on the chart had enabled:
         ChartSetInteger(0,CHART_EVENT_OBJECT_CREATE,1);
         ChartSetInteger(0,CHART_EVENT_OBJECT_DELETE,1);
         For more info, see:   https://www.forexfactory.com/thread/post/13933799#post13933799 
         For the way the button was added, there *may* not be a need to enable 'ChartSetInteger(0,CHART_EVENT_MOUSE_MOVE,1);'  Without it enabled, it seems to work fine.
   New 'stringToPeriod' (replaces 'stringToTimeFrame') supports a better default of "+2", rather than "Current time frame".   With "Current" as the default,
      the indicator literally does nothing, but at least with "+2" as the default, the custom candles show what the candles look
      like on 2-timeframes-higher than the current TF.
   I have no comment on how the rest of this indicator was implemented.  I have my own private indy that does something similar that I used instead.
   There is a 'debug'(false) var, that when set to true, primarily demonstrates an MT4 (or documentation?) bug with 'WindowFind', that it does not return "-1" when it
      searches for itself from within OnInit()/init().
   
   NO further support of this indy by pips4life.   It is provided as-is.

*/
bool debug = false; // P4L: To debug primarily the WindowFind command, set to 'true'

#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window

//
//
//
//
//
//extern string TimeFrame               = "Current time frame"; // Not a useful default.
extern string TimeFrame               = "+2"; // P4L: Two timeframes above the current.  Parsed by new 'stringToPeriod'
extern color  UpCandleColor           = clrHoneydew;
extern color  DownCandleColor         = clrMistyRose;
extern color  NeutralCandleColor      = clrDimGray;
extern int    DrawingWidth            = 1;
extern bool   FilledCandles           = true;
extern bool   HiLoFilled              = true;
extern string UniqueCandlesIdentifier = "CustomCandleAny";
//button template start1; copy and paste
extern string             button_note1          = "------------------------------";
extern int                btn_Subwindow         = 0;
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER; 
extern string             btn_text              = "Candle";
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 10;                        
extern color              btn_text_ON_color     = clrWhite;
extern color              btn_text_OFF_color    = clrRed;
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 20;                                   
extern int                button_y              = 33;                                   
extern int                btn_Width             = 60;                                
extern int                btn_Height            = 20;                               
extern string             button_note2          = "------------------------------";
extern string             unique_id = ""; // P4L: The user sets this when adding >=2 of this indy to the same chart

bool show_data;
//bool recalc    = true;
//string indicatorFileName;
string IndicatorName, IndicatorObjPrefix, buttonId;
//button template end1; copy and paste

int timeFrame;
//+------------------------------------------------------------------------------------------------------------------+
//button template start2; copy and paste

// P4L: Not even going to use this 'GenerateIndicatorName()' routine since it doesn't work (yet).  Rely on 'unique_id' if >=2 of the same indy added to a chart.
//string GenerateIndicatorName(const string target) 
//{
//   string name = target;
//   int try = 2;
//   while (WindowFind(name) != -1) // MT4 BUG!!  Per documentation, WindowFind should return -1 if an indy searches for itself (in init()/OnInit() ), BUT it doesn't work!! Always returns >= 0 !!
//   {
//      name = target + " #" + IntegerToString(try++);
//   } 
//   return name;
//}
//+------------------------------------------------------------------------------------------------------------------+
int OnInit()
{
   // The 'GenerateIndicatorName' uses WindowFind to search for the IndicatorShortName, and if found, use an alternative name, but it doesn't work right.
   //   I would suppose this is an attempt to allow >1 of the same indicator to be added to the chart without conflicts, but this implementation doesn't work.
   //   Furthermore, if not customized, multiple buttons are created at exactly the same spot, which makes it impossible to separately control them (unless 1 button is moved).
   //if(debug) Alert("  winfind=",WindowFind(btn_text) );
   //IndicatorName = GenerateIndicatorName(btn_text);
   //IndicatorObjPrefix = "__" + IndicatorName + "__";
   //IndicatorShortName(IndicatorName); 
   
   //ChartIndicatorName()
   //ChartIndicatorsTotal()
   
   //IndicatorShortName("CustomCandles");
   
   if(debug) 
   {
      // P4L: This proves that WindowFind does NOT return "-1" when an indy searches for itself!  (Contrary to MT4 documentation, so is this a bug?)
      Alert("DEBUG  In OnInit, winfind of this indy name = ", WindowFind(WindowExpertName()) ); 
      for(int j=0;j<ChartIndicatorsTotal(0,0); j++)
      {
         Alert("DEBUG indy#",j,"  name=",ChartIndicatorName(0,0,j),"   winfind=",WindowFind(ChartIndicatorName(0,0,j)),"   chartwinfind=",ChartWindowFind(ChartID(),ChartIndicatorName(0,0,j)));
      }
   }
   IndicatorDigits(Digits);
   
   // P4L: Rely on "unique_id" to be set by the user if >=2 of the same indy is added to the same chart.
   IndicatorObjPrefix = "__" + unique_id + btn_text + "__";
   
   // P4L: This is used to name the candle objects and therefore must include unique_id if >=2 of the same indy is added to the same chart.
   UniqueCandlesIdentifier = unique_id + UniqueCandlesIdentifier;
   
   //indicatorFileName = WindowExpertName();
   
   // P4L: For the way this button was implemented (e.g. it cannot be dragged and moved on the chart), it seems unnecessary to enable 'CHART_EVENT_MOUSE_MOVE'.  And without it, then OnChartEvent will process far fewer events!
   //ChartSetInteger(0, CHART_EVENT_MOUSE_MOVE, 1); 
   buttonId = "_" + IndicatorObjPrefix + "button_";  // P4L: Deliberately distinguished from other objects so the *button* can be kept (in OnDeinit) when changing TF's.
   if(ObjectFind(buttonId)<0) createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   //else if(debug) Alert("DEBUG in OnInit, the button '",buttonId,"' already EXISTS.  state=",ObjectGetInteger(0, buttonId, OBJPROP_STATE),"   color=",ObjectGetInteger(0,buttonId,OBJPROP_COLOR) );
   
   ObjectSetInteger(0, buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(0, buttonId, OBJPROP_XDISTANCE, button_x);
   init2();
   
   // Using an F3 Global Var to record-and-control on/off is not working properly.
   //double val;
   //if (GlobalVariableGet(IndicatorName + "_visibility", val)) show_data = val != 0;
   
   //show_data = true; // enables the button by default
   //ObjectSetInteger(0, buttonId, OBJPROP_STATE,show_data); 
   
   show_data = ObjectGetInteger(0, buttonId, OBJPROP_STATE);
   
   if (show_data) ObjectSetInteger(0,buttonId,OBJPROP_COLOR,btn_text_ON_color); 
   else ObjectSetInteger(0,buttonId,OBJPROP_COLOR,btn_text_OFF_color);

   
return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------------------------------------------------------+
void OnDeinit(const int reason) { 
     ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);
     // P4L: If just changing a TF', the button need not be deleted, therefore the 'OBJPROP_STATE' is also preserved.
     if(reason != REASON_CHARTCHANGE) ObjectDelete(buttonId);
     deinit2();
}
//+------------------------------------------------------------------+
void createButton(string buttonID,string buttonText,int width2,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
  if(debug) Alert("DEBUG   Running 'createButton' now");
      ObjectDelete    (0,buttonID);
      ObjectCreate    (0,buttonID,OBJ_BUTTON,btn_Subwindow,0,0);
      ObjectSetInteger(0,buttonID,OBJPROP_COLOR,txtColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BGCOLOR,bgColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_COLOR,borderColor);
      ObjectSetInteger(0,buttonID,OBJPROP_BORDER_TYPE,BORDER_RAISED);
      ObjectSetInteger(0,buttonID,OBJPROP_XSIZE,width2);
      ObjectSetInteger(0,buttonID,OBJPROP_YSIZE,height);
      ObjectSetString (0,buttonID,OBJPROP_FONT,font);
      ObjectSetString (0,buttonID,OBJPROP_TEXT,buttonText);
      ObjectSetInteger(0,buttonID,OBJPROP_FONTSIZE,fontSize);
      ObjectSetInteger(0,buttonID,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(0,buttonID,OBJPROP_CORNER,btn_corner);
      ObjectSetInteger(0,buttonID,OBJPROP_HIDDEN,1);
      ObjectSetInteger(0,buttonID,OBJPROP_XDISTANCE,9999);
      ObjectSetInteger(0,buttonID,OBJPROP_YDISTANCE,9999);
      // P4L: Upon creation, set the initial state to "true" which is "on", so one will see the CustomCandles by default
      ObjectSetInteger(0, buttonId, OBJPROP_STATE,true);
}
// P4L: No longer using handleButtonClicks
////+------------------------------------------------------------------+
//void handleButtonClicks()
//{
//   if (ObjectGetInteger(0, buttonId, OBJPROP_STATE))
//   {
//      ObjectSetInteger(0, buttonId, OBJPROP_STATE, false);
//      show_data = !show_data;
//      //GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
//      ////recalc = true;
//   }
//}
//+------------------------------------------------------------------------------------------------------------------+
void OnChartEvent(const int id, 
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   // If another indy on the same chart has enabled events for create/delete/mouse-move, just skip this events up front because they aren't
   //    needed, AND in the worst case, this indy might cause MT4 to hang!!  Skipping the events seems to help, along with other (major) changes to the code below.
   if(id==CHARTEVENT_OBJECT_CREATE || id==CHARTEVENT_OBJECT_DELETE) return; // This appears to make this indy compatible with other programs that enabled CHART_EVENT_OBJECT_CREATE and/or CHART_EVENT_OBJECT_DELETE
   if(id==CHARTEVENT_MOUSE_MOVE || id==CHARTEVENT_MOUSE_WHEEL) return; // If this, or another program, enabled mouse-events, these are not needed below, so skip it unless actually needed.
   
   //handleButtonClicks();  // NO!!  Why do this for every single id event??  
   
   //if (id==CHARTEVENT_OBJECT_CLICK && ObjectGet(sparam,OBJPROP_TYPE)==OBJ_BUTTON)
   //start();
   
   //if (id==CHARTEVENT_OBJECT_CLICK && ObjectGet(sparam,OBJPROP_TYPE)==OBJ_BUTTON) // Why check for ANY button clicked?  Only check for the specific buttonId objname
   
   // P4L: ONLY the specific buttonId is checked, rather than ANY button.
   if (id==CHARTEVENT_OBJECT_CLICK && sparam == buttonId)
   {
      //handleButtonClicks(); // P4L: Skip running this separate routine; just do the equivalent steps below
      //start(); //redundant to below
      
      show_data = ObjectGetInteger(0, buttonId, OBJPROP_STATE);
      // P4L: No longer using any GVars to store on/off state
      //GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      
      // P4L: Previously, the if/else below was done for EVERY event!  This was hugely wasteful since it runs 'start()' far too many times!! 
      //    It might have also caused MT4 to 'hang', but inside this specific event seems ok now.  (Likely the 'deinit2()' which runs a foreach_object caused the hang, because it used to run EVERY time (when off)
      if (show_data)
      {
         ObjectSetInteger(0,buttonId,OBJPROP_COLOR,btn_text_ON_color); 
         // P4L: Is it a problem to call 'start()' ??  Would it be better, or no difference, to rename 'start()' to 'mystart()', and call 'mystart()' here instead; And of course, also define: 'int start() { return( mystart() ); }'
         start();
      }
      else
      {
         ObjectSetInteger(0,buttonId,OBJPROP_COLOR,btn_text_OFF_color);
         // P4L: This deinit2, which runs deleteCandles(), will now ONLY run one time when the actual button is pushed to turn it off.
         deinit2();
      }
   }
}
//button template end2; copy and paste
//+------------------------------------------------------------------------------------------------------------------+
int init2()
{
   //timeFrame = stringToTimeFrame(TimeFrame); 
   timeFrame = stringToPeriod(TimeFrame,true); // Replaced stringToTimeFrame with this more flexible stringToPeriod, that can handle, for example, "+2" as 2 timeframes above the current TF
   //if (MathFloor(timeFrame/Period())*Period() != timeFrame) timeFrame = Period(); // No, does not always work for larger TF's, plus not necessary due to 'stringToPeriod(TimeFrame,TRUE)'
   return(0);
}
//+------------------------------------------------------------------------------------------------------------------+
int deinit2() { deleteCandles(); Comment("");return(0); }
//+------------------------------------------------------------------------------------------------------------------+

// P4L: Consider renaming this 'start()' to 'mystart()', AND then:  int start() { return( mystart() ); }   and having the OnInit() call 'mystart()' instead of 'start()'.  Is there any difference??  Might it help??

int start()
{
   if (show_data)
   {
      static int oldBars = 0;
      int counted_bars=IndicatorCounted();
      int i,limit;
   
      // P4L: Cleaned up the formatting so it's more clear what is inside of this 'if/then' section.
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
      
      //limit=MathMin(Bars-counted_bars,Bars-1);
      limit = Bars;
      if (oldBars!=Bars)
      {
         deleteCandles();
            oldBars = Bars;
            limit   = Bars-1;
      }               
   
      //
      //
      //
      //
      //
      
      for (i=limit; i>= 0; i--)
      {
         datetime startingTime;
         int      barsPassed;
         int      startOfThisBar;
   
            while (true)
            {
               if (timeFrame<60)
               {
                  startingTime   = StrToTime(TimeToStr(Time[i],TIME_DATE)+toHour(TimeHour(Time[i])));
                  barsPassed     = MathFloor((Time[i]-startingTime)/(timeFrame*60));
                  startOfThisBar = iBarShift(NULL,0,startingTime+barsPassed*timeFrame*60);
                  break;
               }
               if (timeFrame<1440)
               {
                  startingTime   = StrToTime(TimeToStr(Time[i],TIME_DATE)+" 00:00");
                  barsPassed     = MathFloor((Time[i]-startingTime)/(timeFrame*60));
                  startOfThisBar = iBarShift(NULL,0,startingTime+barsPassed*timeFrame*60);
                  break;
               }
               startingTime   = iTime(NULL,timeFrame,iBarShift(NULL,timeFrame,Time[i]));
               startOfThisBar = iBarShift(NULL,0,startingTime);
               break;
            }         
   
            //
            //
            //
            //
            //
            
               datetime startTime  = Time[startOfThisBar];
               datetime endTime    = startTime+(timeFrame-1)*60;
               double   openPrice  = Open[startOfThisBar];
               double   closePrice = Close[startOfThisBar];
               double   highPrice  = High[startOfThisBar];
               double   lowPrice   = Low[startOfThisBar];
            
               for (int k=1; Time[startOfThisBar-k]>0 && Time[startOfThisBar-k]<=endTime; k++)
                  {
                     closePrice = Close[startOfThisBar-k];
                     highPrice  = MathMax(highPrice,High[startOfThisBar-k]);
                     lowPrice   = MathMin(lowPrice,Low[startOfThisBar-k]);
                  }
   
            //
            //
            //
            //
            //
            
            drawCandle(startTime,endTime,openPrice,closePrice,highPrice,lowPrice);
      }
   
      //
      //
      //
      //
      // P4L: This comment is now done inside the "if/then" condition, as it should be.
      Comment("Current "+Symbol()+" "+timeFrameToString(timeFrame)+" candle : ",DoubleToStr(openPrice,Digits),",",DoubleToStr(highPrice,Digits),",",DoubleToStr(lowPrice,Digits),",",DoubleToStr(closePrice,Digits));
      // P4L: The comment is cleared when the button is clicked to "off" condition.
   }//end if(show_data)
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string toHour(int hour)
{
   if (hour<10)
         return(" 0"+hour+":00");
   else  return(" " +hour+":00");
}

//
//
//
//
//

void deleteCandles()
{
   int searchLength = StringLen(UniqueCandlesIdentifier);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string name = ObjectName(i);
         if (StringSubstr(name,0,searchLength) == UniqueCandlesIdentifier)  ObjectDelete(name);
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void drawCandle(datetime startTime, datetime endTime, double openPrice, double closePrice, double highPrice, double lowPrice)
{
   color candleColor = NeutralCandleColor;
   
      if (closePrice>openPrice) candleColor = UpCandleColor;
      if (closePrice<openPrice) candleColor = DownCandleColor;

   //
   //
   //
   //
   //
   if(HiLoFilled){
       string hlname = UniqueCandlesIdentifier+":"+startTime;
      if (ObjectFind(hlname)==-1)
          ObjectCreate(hlname,OBJ_RECTANGLE,0,startTime,openPrice,endTime,closePrice);
             ObjectSet(hlname,OBJPROP_PRICE1,highPrice);
             ObjectSet(hlname,OBJPROP_PRICE2,lowPrice);
             ObjectSet(hlname,OBJPROP_TIME2 ,endTime);
             ObjectSet(hlname,OBJPROP_COLOR ,candleColor);
             ObjectSet(hlname,OBJPROP_STYLE ,STYLE_SOLID);
             ObjectSet(hlname,OBJPROP_BACK  ,FilledCandles);
             ObjectSet(hlname,OBJPROP_WIDTH ,DrawingWidth);
      }else{   
         string name = UniqueCandlesIdentifier+":"+startTime;
      if (ObjectFind(name)==-1)
          ObjectCreate(name,OBJ_RECTANGLE,0,startTime,openPrice,endTime,closePrice);
             ObjectSet(name,OBJPROP_PRICE1,openPrice);
             ObjectSet(name,OBJPROP_PRICE2,closePrice);
             ObjectSet(name,OBJPROP_TIME2 ,endTime);
             ObjectSet(name,OBJPROP_COLOR ,candleColor);
             ObjectSet(name,OBJPROP_STYLE ,STYLE_SOLID);
             ObjectSet(name,OBJPROP_BACK  ,FilledCandles);
             ObjectSet(name,OBJPROP_WIDTH ,DrawingWidth);
             
      //
      //
      //
      //
      //
                   
      datetime wickTime = startTime+(endTime-startTime)/2;
      double   upPrice  = MathMax(closePrice,openPrice);
      double   dnPrice  = MathMin(closePrice,openPrice);
      
      string   wname = name+":+";
      if (ObjectFind(wname)==-1)
          ObjectCreate(wname,OBJ_TREND,0,wickTime,highPrice,wickTime,upPrice);
             ObjectSet(wname,OBJPROP_PRICE1,highPrice);
             ObjectSet(wname,OBJPROP_PRICE2,upPrice);
             ObjectSet(wname,OBJPROP_TIME1 ,wickTime);
             ObjectSet(wname,OBJPROP_TIME2 ,wickTime);
             ObjectSet(wname,OBJPROP_COLOR ,candleColor);
             ObjectSet(wname,OBJPROP_STYLE ,STYLE_SOLID);
             ObjectSet(wname,OBJPROP_RAY   ,false);
             ObjectSet(wname,OBJPROP_WIDTH ,DrawingWidth);

      wname = name+":-";
      if (ObjectFind(wname)==-1)
          ObjectCreate(wname,OBJ_TREND,0,wickTime,dnPrice,wickTime,lowPrice);
             ObjectSet(wname,OBJPROP_PRICE1,dnPrice);
             ObjectSet(wname,OBJPROP_PRICE2,lowPrice);
             ObjectSet(wname,OBJPROP_TIME1 ,wickTime);
             ObjectSet(wname,OBJPROP_TIME2 ,wickTime);
             ObjectSet(wname,OBJPROP_COLOR ,candleColor);
             ObjectSet(wname,OBJPROP_STYLE ,STYLE_SOLID);
             ObjectSet(wname,OBJPROP_RAY   ,false);
             ObjectSet(wname,OBJPROP_WIDTH ,DrawingWidth);
             }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//
//
//
//
//
// P4L:  This 'stringToPeriod' is from my library of functions.  It may be overly complex, but it handes relative-TF's, e.g. "+2" is two-TF's above the current TF.
int stringToPeriod(string tfs, bool AtOrAboveCurrent=false, bool ZeroReturnsZero=false, bool outOfRelativeRangeTooHiOrLo_Minus8_9=false)
{     
   StringToUpper(tfs);      
   tfs = StringTrimLeft(StringTrimRight(tfs));
   if ( StringFind(tfs,"CUR") == 0 || tfs == "0") { if (ZeroReturnsZero) return(0); else return(Period()); }
   
   int _TFlist[9] = {1, 5, 15, 30, 60, 240, 1440, 10080, 43200}; // Typ 9 standard TFs // The code prevents a [9] from ever occuring.
   int tf=-1; // WAS 0, but -1 is more clear, to insist a legal value be found.
   int len = StringLen(tfs);
   int num,numlen;
   int pos=-1;
   string tfsLetters;
      
   int k,j,r;
   if (StringFind(tfs,"+",0) == 0) 
   {
      r=StrToInteger(StringSubstr(tfs,1));
      if( len==1+StringLen(IntegerToString(r)) )
      {
         for (k = 0; k <= 8; k++)
           {
            if (Period() != _TFlist[k]) continue;
            j=k+r;
            if (j>8) 
            {
               if(outOfRelativeRangeTooHiOrLo_Minus8_9) return(-8);
               else j=8;
            }
            //j=MathMin(8,k+StrToInteger(StringSubstr(tfs,1)));
            tf = _TFlist[j];
            break;
           }
      }
   }
   else if (StringFind(tfs,"-",0) == 0) 
   {
      r=StrToInteger(StringSubstr(tfs,1));
      if( len==1+StringLen(IntegerToString(r)) )
      {
         for (k = 0; k <= 8; k++)
           {
            if (Period() != _TFlist[k]) continue;
            j=k-r;
            if(j<0)
            {
               if(outOfRelativeRangeTooHiOrLo_Minus8_9) return(-9);
               else j=0;
            }
            //j=MathMax(0,k-StrToInteger(StringSubstr(tfs,1)));
            tf = _TFlist[j];
            break;
           }
       }
   }
   else if (StringFind(tfs,"MIN",0) >= 0)
   {
      //tfs = stringReplaceFirstMatch(tfs,"MINUTE","");
      //tfs = stringReplaceFirstMatch(tfs,"MIN","");
      //tf = MathMax(1,StrToInteger(tfs));
      if(tfs=="MIN1" || tfs=="MIN" || tfs=="1MIN" || tfs=="MINUTE" || tfs=="1MINUTE") tf=PERIOD_M1;
      else
      {
         num = StrToInteger(StringSubstr(tfs,stringFindFirst_1thru9(tfs)));
         numlen = StringLen(IntegerToString(num));
         if(num>0 && ( 
                           (StringFind(tfs,"MIN",0)>=0 && len==3+numlen) 
                        || (StringFind(tfs,"MINS",0)==0 && len==4+numlen ) // By convention, only "#MINS", not "MINS#" 
                        || (StringFind(tfs,"MINUTES",0)==0 && len==7+numlen) // By convention, only "#MINUTES", not "MINUTES#" 
                     )      
         ) tf=num; //*PERIOD_M1;
      }
   }
   else if (StringFind(tfs,"N",0) >= 0 || StringFind(tfs,"MO",0) >= 0)
   {
      //tfs = stringReplaceFirstMatch(tfs,"MONTHLY","");
      //tfs = stringReplaceFirstMatch(tfs,"MONTH","");
      //tfs = stringReplaceFirstMatch(tfs,"MON","");
      //tfs = stringReplaceFirstMatch(tfs,"MO","");
      //tfs = stringReplaceFirstMatch(tfs,"N","");
      //tfs = stringReplaceFirstMatch(tfs,"M","");
      //tf = MathMax(1,StrToInteger(tfs))*PERIOD_MN1;
      //TOO LAX//tf = MathMax(1,StrToInteger(StringSubstr(tfs,stringFindFirst_1thru9(tfs))))*PERIOD_MN1;
      if(tfs=="MN1" || tfs=="MONTHLY" || tfs=="1MN" || tfs=="MN" || tfs=="MO" || tfs=="MO1" || tfs=="1MO" || tfs=="MON" || tfs=="MON1" || tfs=="1MON" || tfs=="MONTH" || tfs=="MONTH1" || tfs=="1MONTH"
         || tfs=="N" || tfs=="N1" || tfs=="1N" // COMMENT OUT if "N" support is not desired
        ) tf=PERIOD_MN1;
      else
      {
         num = StrToInteger(StringSubstr(tfs,stringFindFirst_1thru9(tfs)));
         numlen = StringLen(IntegerToString(num));
         if(num>0 && ( 
                           (StringFind(tfs,"MN",0)>=0 && len==2+numlen )
                        || (StringFind(tfs,"N",0)>=0 && len==1+numlen)  // COMMENT OUT if "N#" or "#N" support is not desired
                     )      
         ) tf=num*PERIOD_MN1;
         else 
         {
            pos=StringFind(tfs,"MO"); // At least the 2 characters "MO"  // COMMENT OUT if "MO#" or "#MO" support is not desired! (where "MO" is that or anything up to "MONTHLY") 
            if(pos>=0)
            {
               if(pos==0) tfsLetters=StringSubstr(tfs,0,len-numlen);
               else tfsLetters=StringSubstr(tfs,numlen);
               if(StringFind("MONTH",tfsLetters)==0) tf=num*PERIOD_MN1; // nothing not in common.
            }
         }
      }
   }
   else if (StringFind(tfs,"M",0) >= 0) // This is *after* "MIN" and "MO"/"MN"
   {
      //tfs = stringReplaceFirstMatch(tfs,"M","");
      //tf = MathMax(1,StrToInteger(tfs));
      if(tfs=="M1" || tfs=="M" || tfs=="1M") tf=PERIOD_M1;
      else
      {
         num = StrToInteger(StringSubstr(tfs,stringFindFirst_1thru9(tfs)));
         numlen = StringLen(IntegerToString(num));
         if(num>0 && ( 
                           (StringFind(tfs,"M",0)>=0 && len==1+numlen) 
                     )      
         ) tf=num; //*PERIOD_M1;
      }
   }
   else if (StringFind(tfs,"W",0) >= 0)
   {
      //tfs = stringReplaceFirstMatch(tfs,"WEEKLY","");
      //tfs = stringReplaceFirstMatch(tfs,"WEEK","");
      //tfs = stringReplaceFirstMatch(tfs,"W","");
      //tfs = stringReplaceFirstMatch(tfs,"K","");
      //tf = MathMax(1,StrToInteger(tfs))*PERIOD_W1;
      if(tfs=="W1" || tfs=="WEEKLY" || tfs=="W" || tfs=="1W" || tfs=="WK" || tfs=="WK1" || tfs=="1WK" || tfs=="WEEK") tf=PERIOD_W1;
      else
      {
         num = StrToInteger(StringSubstr(tfs,stringFindFirst_1thru9(tfs)));
         numlen = StringLen(IntegerToString(num));
         if(num>0 && ( 
                           (StringFind(tfs,"W",0)>=0 && len==1+numlen) 
                        || (StringFind(tfs,"WK",0)>=0 && len==2+numlen )
                        || (StringFind(tfs,"WEEK",0)>=0 && len==4+numlen) 
                        || (StringFind(tfs,"WEEKS",0)==0 && len==5+numlen)  // By convention, only "#WEEKS", not "WEEKS#" 
                     )      
         ) tf=num*PERIOD_W1;
      }
   }
   else if (StringFind(tfs,"D",0) >= 0)
   {
      //tfs = stringReplaceFirstMatch(tfs,"DAILY","");
      //tfs = stringReplaceFirstMatch(tfs,"DAY","");
      //tfs = stringReplaceFirstMatch(tfs,"D","");
      //tf = MathMax(1,StrToInteger(tfs))*PERIOD_D1; // V3_19 FIXED BUG!!! Was PERIOD_W1, is PERIOD_D1
      if(tfs=="D1" || tfs=="D" || tfs=="1D" || tfs=="DAILY" || tfs=="DAY" || tfs=="DAY1" || tfs=="1DAY") tf=PERIOD_D1;
      else
      {
         num = StrToInteger(StringSubstr(tfs,stringFindFirst_1thru9(tfs)));
         numlen = StringLen(IntegerToString(num));
         if(num>0 && ( 
                           (StringFind(tfs,"D",0)>=0 && len==1+numlen) 
                        || (StringFind(tfs,"DAY",0)>=0 && len==3+numlen )
                        || (StringFind(tfs,"DAYS",0)==0 && len==4+numlen) // By convention, only "#DAYS", not "DAYS#" 
                     )      
         ) tf=num*PERIOD_D1;
      }
   }
   else if (StringFind(tfs,"H",0) >= 0)
   {
      //tfs = stringReplaceFirstMatch(tfs,"HOURLY","");
      //tfs = stringReplaceFirstMatch(tfs,"HOUR","");
      //tfs = stringReplaceFirstMatch(tfs,"HR","");
      //tfs = stringReplaceFirstMatch(tfs,"H","");
      //tf = MathMax(1,StrToInteger(tfs))*PERIOD_H1;
      if(tfs=="H1" || tfs=="H" || tfs=="1H" || tfs=="HR" || tfs=="HR1" || tfs=="1HR" || tfs=="HOUR" || tfs=="HOUR1" || tfs=="1HOUR" || tfs=="HOURLY") tf=PERIOD_H1;
      else
      {
         num = StrToInteger(StringSubstr(tfs,stringFindFirst_1thru9(tfs)));
         numlen = StringLen(IntegerToString(num));
         if(num>0 && ( 
                           (StringFind(tfs,"H",0)>=0 && len==1+numlen) 
                        || (StringFind(tfs,"HR",0)>=0 && len==2+numlen )
                        || (StringFind(tfs,"HOUR",0)>=0 && len==4+numlen)
                        || (StringFind(tfs,"HOURS",0)==0 && len==5+numlen) // By convention, only "#HOURS", not "HOURS#" 
                     )      
         ) tf=num*PERIOD_H1;
      }
   }
   
   if (AtOrAboveCurrent && tf>0 && tf<Period()) tf=Period();
   
   if(tf>0) return(tf);
   num = StrToInteger(tfs);
   numlen = StringLen(IntegerToString(num));
   if (num > 0 && len==numlen) return(StrToInteger(tfs)); // Minutes.  Any number must be exactly that; no extra strings. OLD: Although "30X" would ignore the "X" and return "30". "30D" would be caught above, hence this should be last. 
   
   return(-1); // Illegal entry
}//end of stringToPeriod()
//+------------------------------------------------------------------+
int stringFindFirst_1thru9(string str, bool includeZero=false, bool includePeriod=false, bool includePlus=false, bool includeMinus=false) export
{
   int asciiLo=49; //"1"=49,  "9"=57
   if(includeZero) asciiLo=48; // "0"=48
   int len = StringLen(str);
   for(int pos=0; pos<len; pos++)
   {
      ushort u_char=StringGetChar(str,pos);
      if(u_char >= asciiLo && u_char <= 57) return(pos);
      if(includePeriod && u_char==46 ) return(pos); // "."=46
      if(includePlus   && u_char==43 ) return(pos); // "+"=43
      if(includeMinus  && u_char==45 ) return(pos); // "-"=45
      // 
   }
   return(-1);
}//end of stringFindFirst_1thru9()
//+------------------------------------------------------------------+
//
//
//
string sTfTable[] = {"M1","M2","M3","M4","M5","M6","M10","M12","M15","M20","M30","H1","H2","H3","H4","H6","H8","H12","D1","W1","MN"};
int    iTfTable[] = {1,2,3,4,5,6,10,12,15,20,30,60,120,180,240,360,480,720,1440,10080,43200};
//
// P4L: replaced this with stringToPeriod
//int stringToTimeFrame(string tfs)
//{
//   tfs = StringUpperCase(tfs);
//   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
//         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
//                                                      return(Period());
//}

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//
//
//string StringUpperCase(string str)
//{
//   string   s = str;
//
//   for (int length=StringLen(str)-1; length>=0; length--)
//   {
//      int s_char = StringGetChar(s, length);
//         if((s_char > 96 && s_char < 123) || (s_char > 223 && s_char < 256))
//                     s = StringSetChar(s, length, s_char - 32);
//         else if(s_char > -33 && s_char < 0)
//                     s = StringSetChar(s, length, s_char + 224);
//   }
//   return(s);
//}